library("tsne")
library("Rtsne")

path="~/Dropbox/MST_COURSES/SS16/R/"

mydata <- read.table(paste0(path,"samplewordembedding.csv"),sep = ",",header=TRUE)

#alternative experimenting with pima-indians dataset
#mydata = read.table(paste0(path,"pima-indians-diabetes.data"),sep = ",",header=FALSE)
#mydata1 = mydata[1:300,1:8]

# initialize counter to 0
x <- 0

# run tsne (maximum iterations:500, target dimension k=5)
tsne_data <- tsne(mydata1, k=5, max_iter=500, epoch=100)

jpeg(paste0(path,"tsne-plot.jpg"), width=2400, height=1800)
plot(tsne_data, t='n', main="tSNE")
text(tsne_data, labels=rownames(mydata))
dev.off()

#alternative implementation of Rtsne
#run Rtsne with default parameters
rtsne_out <- Rtsne(as.matrix(mydata))

# plot the output of Rtsne into d:\\barneshutplot.jpg file of 2400x1800 dimension
jpeg(paste0(path,"barneshutplot.jpg"), width=2400, height=1800)
plot(rtsne_out$Y, t='n', main="BarnesHutSNE")
text(rtsne_out$Y, labels=rownames(mydata))
dev.off()